<?php
if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    // get the uploaded files
    $files = $_FILES['files'];

    // a function to get file contents and return as string
    function getFileContents($fileTmpName) {
        $content = file_get_contents($fileTmpName);
        if ($content === false) {
            die('Failed to read file "' . $fileTmpName . '".');
        }
        return $content;
    }

    $svgFiles = [];
    $jsFiles = [];
    $jsObject = 'var scenes = {';

    // divide the files into SVGs and JSs
    for ($i = 0; $i < count($files['name']); $i++) {
        $extension = pathinfo($files['name'][$i], PATHINFO_EXTENSION);
        if ($extension === 'svg') {
            $svgFiles[] = getFileContents($files['tmp_name'][$i]);
        } else if ($extension === 'js') {
            $jsFiles[] = getFileContents($files['tmp_name'][$i]);
        }
    }

    for ($i = 0; $i < count($svgFiles); $i += 2) {
        $mobileSVG = addslashes($svgFiles[$i]);
        $desktopSVG = addslashes($svgFiles[$i + 1]);

        $jsObject .= '"szene_' . (($i / 2) + 1) . '": {';
        $jsObject .= '"layout_mob": `' . $mobileSVG . '`,';
        $jsObject .= '"layout_dt": `' . $desktopSVG . '`';
        $jsObject .= '},';
    }

    $jsObject = rtrim($jsObject, ',');
    $jsObject .= '};';

    // Add the contents of the JS files to the end of the JavaScript object
    foreach ($jsFiles as $jsContent) {
        $jsObject .= "\n" . $jsContent;
    }

    // set a unique name for the temp file
    $tempFilename = uniqid('temp_', true) . '.js';

    // write the JS object to a temp file
    if (!file_put_contents($tempFilename, $jsObject)) {
        http_response_code(500);
        echo 'Fehler beim Schreiben der JS-Datei.';
        exit();
    }

    // send the temp file name back to JS
    echo $tempFilename;
}


if (isset($_GET['download'])) {
    $tempFilename = $_GET['download'];

    // ensure the file exists and is a valid file
    if (is_file($tempFilename) && strpos($tempFilename, 'temp_') === 0) {
        // set the headers to force download
        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename="finalOutput.js"');
        header('Content-Length: ' . filesize($tempFilename));

        // output the file content
        readfile($tempFilename);

        // delete the temp file
        unlink($tempFilename);
    }

    exit();
}
?>